--con preguntas de astronomía y generales,
require "import"
import "android.media.MediaPlayer"
import "android.widget.*"
import "com.androlua.*"

sergio = {
  "preguntas variadas de cultura general",
"sobre astronomía",
}
-- Función para obtener la ruta de los archivos de sonido
function get_file_path(filename)
  local path1 = "/storage/emulated/0/解说/Plugins/" .. filename
  local path2 = "/storage/emulated/0/解说/Complementos/" .. filename
  if file_exists(path1) then
    return path1
  elseif file_exists(path2) then
    return path2
  else
    return nil
  end
end

-- Función para verificar si un archivo existe
function file_exists(path)
  local file = io.open(path, "r")
  if file then
    io.close(file)
    return true
  else
    return false
  end
end

-- Lista de archivos de sonido


files = { 
"el juego de preguntas/healer_hit_02.ogg",
"el juego de preguntas/town_hall_upgrade_jingle_01.ogg",
"el juego de preguntas/wiz_death_vo_02.ogg",
"el juego de preguntas/sb_deploy_01.ogg",
"el juego de preguntas/clash_pet_horse_die_01.ogg",
"el juego de preguntas/leg_league_01.ogg",
"el juego de preguntas/candy_crush_soundtrack3.ogg",
"el juego de preguntas/supercell_jingle.ogg",
"el juego de preguntas/tutor_talk_aha_01.ogg",
"el juego de preguntas/clan_task_failed_01.ogg",
"el juego de preguntas/EFECTO DE SONIDO ¡WOW! (Chroma key).m4a",
"el juego de preguntas/últimas cinco preguntas.m4a",
"el juego de preguntas/el juego de preguntas.m4a"
}
function play_music(index, volume)
local file_path = get_file_path(files[index])
if file_path == nil then
print("Archivo no encontrado: " .. files[index])
return
end
local mp = MediaPlayer()
mp.setDataSource(file_path)

  mp.setVolume(volume, volume)
  mp.prepare()
  mp.start()
  mp.setOnCompletionListener(MediaPlayer.OnCompletionListener {
      onCompletion = function()
          mp.release()
      end
  })
end


play_music(2, 0.5)
play_music(13, 1.0)



layout={
GridView,
id="grid",
numColumns=1,
--items=sergio,
layout_width="fill",
layout_height="fill"
}

dlg=LuaDialog(service)
dlg.View=loadlayout(layout)
grid.adapter=SingleLineAdapter(service,String(sergio))
dlg.show()
grid.onItemClick=function(l,v)
task(100,function()
dlg.dismiss()


if v.text == "sobre astronomía" then
--con preguntas de astronomía,
--resuelto compatibilidad con ambas carpetas, 
--enseña todas las preguntas con todas sus respuestas correctas
--agregar botón cerrar, listo,
--música en toda la ronda listo,
--sonido en botones listo,
--juego de preguntas
require "import"
import "android.media.MediaPlayer"
import "android.widget.*"
import "com.androlua.*"
math.randomseed(os.time())
-- Inicializa un contador de tiempo inicial
start_time = os.time()
-- Función para verificar si el tiempo se ha acabado
function time_is_up()
return os.time() - start_time >= 90

end


-- Crea una lista de preguntas y respuestas
questions = {
{
question = "¿Cuántas lunas tiene el planeta Marte?",
answers = {
{ text = "22", correct = false },
{ text = "1", correct = false },
{ text = "Phobos y Deimos", correct = true },
{ text = "No tiene lunas", correct = false },
},
},

{
question = "¿Cuál es la temperatura más fría del universo?",
answers = {
{ text = "0 grados Celsius", correct = false },
{ text = "0 grados Kelvin", correct = true },
{ text = "0 grados Fahrenheit", correct = false },
{ text = "100 grados Kelvin", correct = false },
},
},
{
question = "¿Cuál es la distancia del universo observable?",
answers = {
{ text = "93 millones de años luz", correct = false },
{ text = "13.8 años luz", correct = false },
{ text = "93 mil millones de años luz", correct = false },
{ text = "46.5 mil millones de años luz", correct = true },
},
},
{
question = "¿Cuál es el objeto más grande conocido en el universo?",
answers = {
{ text = "La Vía Láctea", correct = false },
{ text = "El Cúmulo de Coma", correct = false },
{ text = "La Gran Muralla de Hércules-Corona Boreal", correct = true },
{ text = "El Cúmulo de Virgo", correct = false },
},
},


{
question = "¿Cuál es el nombre del cohete de SpaceX que ha llevado al astronauta japonés Soichi Noguchi al espacio en dos ocasiones?",
answers = {
{ text = "Falcon Heavy", correct = false },
{ text = "Falcon 9", correct = true },
{ text = "Starship", correct = false },
{ text = "Dragon", correct = false },
},
},

{
question = "¿Cuál fue el primer cohete en poner un ser humano en órbita?",
answers = {
{ text = "Vostok 1", correct = true },
{ text = "Apollo 11", correct = false },
{ text = "Mercury-Redstone 3", correct = false },
{ text = "Sputnik 1", correct = false },
},
},
{
question = "¿Cuál es el nombre de la nave espacial de SpaceX que ha llevado astronautas a la Estación Espacial Internacional?",
answers = {
{ text = "Dragon", correct = true },
{ text = "Orion", correct = false },
{ text = "Starliner", correct = false },
{ text = "Soyuz", correct = false },
},
},
{
question = "¿Cuál es el nombre del programa espacial chino que ha llevado a cabo misiones tripuladas y ha construido una estación espacial?",
answers = {
{ text = "Chang'e", correct = false },
{ text = "Tiangong", correct = true },
{ text = "Shenzhou", correct = false },
{ text = "Yutu", correct = false },
},
},
{
question = "¿Cuál es el nombre del proyecto de la NASA que tiene como objetivo llevar astronautas a la Luna nuevamente?",
answers = {
{ text = "Mars 2020", correct = false },
{ text = "Artemis", correct = true },
{ text = "Voyager", correct = false },
{ text = "New Horizons", correct = false },
},
},


{
question = "¿Cuál es el nombre del telescopio espacial que se lanzó en 1990 y ha producido imágenes impresionantes del universo?",
answers = {
{ text = "Chandra", correct = false },
{ text = "Hubble", correct = true },
{ text = "Spitzer", correct = false },
{ text = "Kepler", correct = false },
},
},
{
question = "¿Cuál es el nombre del primer objeto interestelar que se detectó en nuestro sistema solar?",
answers = {
{ text = "Halley", correct = false },
{ text = "Eris", correct = false },
{ text = "Oumuamua", correct = true },
{ text = "Sedna", correct = false },
},
},
{
question = "¿Cuál es el nombre de la sonda espacial de la NASA que ha estado orbitando Júpiter desde 2016?",
answers = {
{ text = "Viking", correct = false },
{ text = "Galileo", correct = false },
{ text = "Juno", correct = true },
{ text = "Pioneer", correct = false },
},
},
{
question = "¿Cuál es el nombre de la teoría que describe la expansión acelerada del universo?",
answers = {
{ text = "Ley de Hubble", correct = false },
{ text = "Teoría de la Relatividad General", correct = false },
{ text = "Teoría del Big Bang", correct = false },
{ text = "Energía Oscura", correct = true },
},
},

{
question = "¿Cuál es el nombre de la sonda que la NASA envió a Marte en julio de 2020?",
answers = {
{ text = "Mars Rover", correct = false },
{ text = "Perseverance", correct = true },
{ text = "Opportunity", correct = false },
{ text = "Spirit", correct = false },
},
},
{
question = "¿Qué es la materia oscura?",
answers = {
{ text = "Materia que no tiene masa", correct = false },
{ text = "Un tipo de materia que solo existe en el espacio exterior", correct = false },
{ text = "Materia que no está presente en la Tierra", correct = false },
{ text = "Una forma de materia que no interactúa con la luz y se cree que es responsable de la gravedad en el universo", correct = true },
},
},
{
question = "¿Qué es el fondo cósmico de microondas?",
answers = {
{ text = "Ondas de radio emitidas por estrellas distantes", correct = false },
{ text = "Radiación electromagnética que se cree que es una remanente del Big Bang", correct = true },
{ text = "Un fenómeno que ocurre cuando un objeto en el espacio exterior explota", correct = false },
{ text = "La emisión de rayos X de una galaxia activa", correct = false },
},
},

{
question = "¿Cuál es el nombre de la sonda espacial que aterrizó en el cometa 67P/Churyumov-Gerasimenko en 2014?",
answers = {
{ text = "Philae", correct = true },
{ text = "Rosetta", correct = false },
{ text = "Galileo", correct = false },
{ text = "Voyager", correct = false },
},
},


{
question = "¿Cuál es la galaxia más cercana a la Vía Láctea?",
answers = {
{ text = "Galaxia del Triángulo", correct = false },
{ text = "Galaxia de la Osa Mayor", correct = false },
{ text = "Galaxia del Sombrero", correct = false },
{ text = "Galaxia de Andrómeda", correct = true },
},
},
{
question = "¿Cuál es la diferencia entre una estrella y un planeta?",
answers = {
{ text = "Los planetas producen su propia luz y calor a través de la fusión nuclear, mientras que las estrellas no", correct = false },
{ text = "Las estrellas y los planetas son lo mismo", correct = false },
{ text = "Las estrellas producen su propia luz y calor a través de la fusión nuclear, mientras que los planetas no", correct = true },
{ text = "Los planetas orbitan alrededor de las estrellas, pero las estrellas no orbitan alrededor de nada", correct = false },
},
},
{
question = "¿Cuál es la temperatura en la superficie del Sol?",
answers = {
{ text = "Alrededor de 5.500 grados Celsius", correct = true },
{ text = "Alrededor de 500 grados Celsius", correct = false },
{ text = "Alrededor de 15.000 grados Celsius", correct = false },
{ text = "Alrededor de 50.000 grados Celsius", correct = false },
},
},
{
question = "¿Cuál es la teoría científica más aceptada sobre el origen del universo?",
answers = {
{ text = "La teoría del universo estacionario", correct = false },
{ text = "La teoría del universo oscilante", correct = false },
{ text = "La teoría de la creación divina", correct = false },
{ text = "La teoría del Big Bang", correct = true },
},
},
{
question = "¿Cuál es la unidad de medida utilizada para medir las distancias en el espacio?",
answers = {
{ text = "Kilómetro", correct = false },
{ text = "Año luz", correct = true },
{ text = "Metro", correct = false },
{ text = "Milla", correct = false },
},
},
{
question = "¿Qué es la nebulosa de Orión?",
answers = {
{ text = "Un objeto en el espacio que emite radiación electromagnética de alta energía", correct = false },
{ text = "Una nube de gas y polvo en la constelación de Orión que se encuentra en proceso de formación estelar", correct = true },
{ text = "Un tipo de estrella que se encuentra en la fase final de su vida", correct = false },
{ text = "Un fragmento de un cuerpo sólido, como un asteroide o un cometa, que ha caído en la Tierra", correct = false },
},
},
{
question = "¿Cuántos planetas en el sistema solar tienen anillos?",
answers = {
{ text = "Cuatro", correct = true },
{ text = "Uno", correct = false },
{ text = "Dos", correct = false },
{ text = "Tres", correct = false },
},
},

{
question = "¿Qué es un tránsito planetario?",
answers = {
{ text = "El paso de un planeta por delante de su estrella, visto desde la Tierra", correct = true },
{ text = "Un objeto en el espacio que emite radiación electromagnética de alta energía", correct = false },
{ text = "Un tipo de estrella que se encuentra en la fase final de su vida", correct = false },
{ text = "Un fragmento de un cuerpo sólido, como un asteroide o un cometa, que ha caído en la Tierra", correct = false },
},
},

{
question = "¿Qué es una supernova?",
answers = {
{ text = "Un objeto en el espacio que emite radiación electromagnética de alta energía", correct = false },
{ text = "Un tipo de estrella que se encuentra en la fase final de su vida", correct = false },
{ text = "Un fragmento de un cuerpo sólido, como un asteroide o un cometa, que ha caído en la Tierra", correct = false },
{ text = "Una explosión de una estrella que libera una gran cantidad de energía y produce elementos más pesados que el hierro", correct = true },
},
},
{
question = "¿Qué es la Nebulosa del Cangrejo?",
answers = {
{ text = "Un objeto rocoso que orbita el Sol y que tiene una cola visible de gas y polvo", correct = false },
{ text = "El remanente de una supernova observada por primera vez en el año 1054", correct = true },
{ text = "Una región del sistema solar que se encuentra entre las órbitas de Marte y Júpiter y que contiene una gran cantidad de asteroides", correct = false },
{ text = "Un objeto en el espacio que emite radiación electromagnética de alta energía", correct = false },
},
},
{
question = "¿Qué es el cúmulo de Virgo?",
answers = {
{ text = "Un cúmulo de galaxias que se encuentra a una distancia de aproximadamente 54 millones de años luz de la Tierra", correct = true },
{ text = "Un objeto en el espacio que emite radiación electromagnética de alta energía", correct = false },
{ text = "Un tipo de estrella que se encuentra en la fase final de su vida", correct = false },
{ text = "Un fragmento de un cuerpo sólido, como un asteroide o un cometa, que ha caído en la Tierra", correct = false },
},
},
{
question = "¿Cuál es el planeta más grande del sistema solar?",
answers = {
{ text = "Saturno", correct = false },
{ text = "Júpiter", correct = true },
{ text = "Urano", correct = false },
{ text = "Neptuno", correct = false },
},
},
{
question = "¿Qué es el cinturón de asteroides?",
answers = {
{ text = "Una región del sistema solar que se encuentra entre las órbitas de Marte y Júpiter y que contiene una gran cantidad de asteroides", correct = true },
{ text = "Un objeto rocoso que orbita el Sol y que tiene una cola visible de gas y polvo", correct = false },
{ text = "Un tipo de estrella que se encuentra en la fase final de su vida", correct = false },
{ text = "Un objeto en el espacio que emite radiación electromagnética de alta energía", correct = false },
},
},
{
question = "¿Qué es un meteorito?",
answers = {
{ text = "Un objeto rocoso que orbita el Sol y que tiene una cola visible de gas y polvo", correct = false },
{ text = "Un fragmento de un cuerpo sólido, como un asteroide o un cometa, que ha caído en la Tierra", correct = true },
{ text = "Un tipo de estrella que se encuentra en la fase final de su vida", correct = false },
{ text = "Un objeto en el espacio que emite radiación electromagnética de alta energía", correct = false },
},
},
{
question = "¿Qué es un planeta enano?",
answers = {
{ text = "Un objeto rocoso que orbita el Sol y que tiene una cola visible de gas y polvo", correct = false },
{ text = "Un tipo de estrella que se encuentra en la fase final de su vida", correct = false },
{ text = "Un objeto en el espacio que emite radiación electromagnética de alta energía", correct = false },
{ text = "Un objeto en el sistema solar que es más grande que un asteroide, pero no lo suficientemente grande como para ser considerado un planeta", correct = true },
},
},

{
question = "¿Qué es un año luz?",
answers = {
{ text = "La distancia que la luz recorre en un año", correct = true },
{ text = "El tiempo que tarda la Tierra en orbitar alrededor del Sol", correct = false },
{ text = "La cantidad de tiempo que tarda la luz en viajar de la Tierra a la Luna", correct = false },
{ text = "La distancia que separa a la Tierra del Sol", correct = false },
},
},
{
question = "¿Qué es una nebulosa?",
answers = {
{ text = "Un objeto en el espacio que emite radiación electromagnética de alta energía", correct = false },
{ text = "Una nube de gas y polvo en el espacio", correct = true },
{ text = "Un tipo de estrella que se encuentra en la fase final de su vida", correct = false },
{ text = "Un objeto rocoso que orbita el Sol y que tiene una cola visible de gas y polvo", correct = false },
},
},
{
question = "¿Qué es una estrella?",
answers = {
{ text = "Un tipo de planeta que se encuentra en el borde exterior del sistema solar", correct = false },
{ text = "Un objeto en el espacio que emite radiación electromagnética de alta energía", correct = false },
{ text = "Un objeto luminoso que se forma a partir de una nube de gas y polvo en el espacio", correct = true },
{ text = "Un agujero negro en el centro de una galaxia", correct = false },
},
},
{
question = "¿Qué es una galaxia?",
answers = {
{ text = "Un sistema formado por un gran número de estrellas, nubes de gas, planetas, polvo cósmico y materia oscura unidos por la gravedad", correct = true },
{ text = "Un objeto en el espacio que emite radiación electromagnética de alta energía", correct = false },
{ text = "Un tipo de estrella que se encuentra en la fase final de su vida", correct = false },
{ text = "Un objeto rocoso que orbita el Sol y que tiene una cola visible de gas y polvo", correct = false },
},
},

{
question = "¿Qué es la Vía Láctea?",
answers = {
{ text = "Un agujero negro supermasivo en el centro del universo", correct = false },
{ text = "Una galaxia espiral en la que se encuentra el sistema solar", correct = true },
{ text = "Un cúmulo de estrellas muy cercano a la Tierra", correct = false },
{ text = "Una estrella muy brillante que puede ser vista desde la Tierra", correct = false },
},
},
{
question = "¿Cuántos planetas hay en nuestro sistema solar?",
answers = {
{ text = "8", correct = true },
{ text = "9", correct = false },
{ text = "10", correct = false },
{ text = "7", correct = false },
},
},
{
question = "¿Qué es un cometa?",
answers = {
{ text = "Un objeto rocoso que orbita el Sol y que tiene una cola visible de gas y polvo", correct = true },
{ text = "Un tipo de estrella que se encuentra en la fase final de su vida", correct = false },
{ text = "Un agujero negro en el centro de una galaxia", correct = false },
{ text = "Un objeto en el espacio que emite radiación electromagnética de alta energía", correct = false },
},
},
{
question = "¿Qué es un eclipse solar?",
answers = {
{ text = "Cuando la Luna se interpone entre la Tierra y el Sol, oscureciendo parcial o totalmente la luz solar", correct = true },
{ text = "Cuando la Tierra se interpone entre el Sol y la Luna, oscureciendo parcial o totalmente la luz lunar", correct = false },
{ text = "Un evento en el que la Tierra, el Sol y la Luna están perfectamente alineados", correct = false },
{ text = "Un fenómeno en el que una gran cantidad de estrellas fugaces caen del cielo", correct = false },
},
},
{
question = "¿Cuál es la estrella más cercana a la Tierra?",
answers = {
{ text = "Sirio", correct = false },
{ text = "Betelgeuse", correct = false },
{ text = "Vega", correct = false },
{ text = "Alfa Centauri", correct = true },
},
},

{
question = "¿Qué planeta es conocido como el planeta rojo?",
answers = {
{ text = "Venus", correct = false },
{ text = "Marte", correct = true },
{ text = "Júpiter", correct = false },
{ text = "Saturno", correct = false },
},
},
{
question = "¿Qué es un agujero negro?",
answers = {
{ text = "Una región del espacio donde la gravedad es tan intensa que nada, ni siquiera la luz, puede escapar", correct = true },
{ text = "Un objeto cósmico que se mueve a través del espacio a velocidades extremadamente altas", correct = false },
{ text = "Una estrella gigante que ha explotado y ha dejado una gran nube de gas y polvo", correct = false },
{ text = "Un objeto en el espacio que emite radiación electromagnética de alta energía", correct = false },
},
},
{
question = "¿Qué es un meteorito?",
answers = {
{ text = "Un objeto que se mueve alrededor del Sol y que tiene una cola visible de gas y polvo", correct = false },
{ text = "Un objeto en el espacio que emite una gran cantidad de radiación electromagnética de alta energía", correct = false },
{ text = "Un fragmento de un asteroide o cometa que ha caído en la Tierra", correct = true },
{ text = "Una estrella gigante que se encuentra en la fase final de su vida", correct = false },
},
},
{
question = "¿Qué son las estrellas fugaces?",
answers = {
{ text = "Objetos que se mueven rápidamente por el espacio y que emiten una gran cantidad de luz", correct = false },
{ text = "Un tipo de asteroide que tiene una cola visible de gas y polvo", correct = false },
{ text = "Pequeñas partículas de polvo y roca que entran en la atmósfera de la Tierra y se queman al entrar en contacto con el aire", correct = true },
{ text = "Estrellas que se mueven a través del espacio a velocidades extremadamente altas", correct = false },
},
},
{
question = "¿Cuál es el nombre del primer hombre en haber caminado sobre la Luna?",
answers = {
{ text = "Buzz Aldrin", correct = false },
{ text = "Neil Armstrong", correct = true },
{ text = "Yuri Gagarin", correct = false },
{ text = "Alan Shepard", correct = false },
},
},

{
question = "¿Cuál es el planeta más cercano al Sol en nuestro sistema solar?",
answers = {
{ text = "Júpiter", correct = false },
{ text = "Venus", correct = false },
{ text = "Mercurio", correct = true },
{ text = "Urano", correct = false },
},
},
{
question = "¿Cuál es la luna más grande de Saturno?",
answers = {
{ text = "Mimas", correct = false },
{ text = "Encélado", correct = false },
{ text = "Titán", correct = true },
{ text = "Iapetus", correct = false },
},
},
{
question = "¿Qué es una estrella de neutrones?",
answers = {
{ text = "Una estrella que ha perdido su brillo y ya no emite luz", correct = false },
{ text = "Una estrella joven y brillante que se encuentra en una fase temprana de su vida", correct = false },
{ text = "Una estrella que ha colapsado bajo su propia gravedad y se ha convertido en una densa bola de neutrones", correct = true },
{ text = "Una estrella gigante roja que se encuentra en la fase final de su vida", correct = false },
},
},
{
question = "¿Cuál es el nombre de la galaxia en la que se encuentra nuestro sistema solar?",
answers = {
{ text = "Andrómeda", correct = false },
{ text = "Vía Láctea", correct = true },
{ text = "Galaxia del Triángulo", correct = false },
{ text = "Galaxia del Sombrero", correct = false },
},
},
{
question = "¿Cuál es el nombre del fenómeno en el que una luna eclipsa a su planeta, proyectando una sombra sobre el planeta?",
answers = {
{ text = "Eclipse solar", correct = false },
{ text = "Transit", correct = false },
{ text = "Eclipse lunar", correct = true },
{ text = "Eclipse solar", correct = false },
},
  },
}
-- Función para obtener la ruta de los archivos de sonido
function get_file_path(filename)
  local path1 = "/storage/emulated/0/解说/Plugins/" .. filename
  local path2 = "/storage/emulated/0/解说/Complementos/" .. filename
  if file_exists(path1) then
    return path1
  elseif file_exists(path2) then
    return path2
  else
    return nil
  end
end

-- Función para verificar si un archivo existe
function file_exists(path)
  local file = io.open(path, "r")
  if file then
    io.close(file)
    return true
  else
    return false
  end
end

-- Lista de archivos de sonido


files = { 
"el juego de preguntas/healer_hit_02.ogg",
"el juego de preguntas/town_hall_upgrade_jingle_01.ogg",
"el juego de preguntas/wiz_death_vo_02.ogg",
"el juego de preguntas/sb_deploy_01.ogg",
"el juego de preguntas/clash_pet_horse_die_01.ogg",
"el juego de preguntas/leg_league_01.ogg",
"el juego de preguntas/candy_crush_soundtrack3.ogg",
"el juego de preguntas/supercell_jingle.ogg",
"el juego de preguntas/tutor_talk_aha_01.ogg",
"el juego de preguntas/clan_task_failed_01.ogg",
"el juego de preguntas/EFECTO DE SONIDO ¡WOW! (Chroma key).m4a",
"el juego de preguntas/últimas cinco preguntas.m4a"
}
function play_music(index, volume)
local file_path = get_file_path(files[index])
if file_path == nil then
print("Archivo no encontrado: " .. files[index])
return
end
local mp = MediaPlayer()
mp.setDataSource(file_path)

  mp.setVolume(volume, volume)
  mp.prepare()
  mp.start()
  mp.setOnCompletionListener(MediaPlayer.OnCompletionListener {
      onCompletion = function()
          mp.release()
      end
  })
end


play_music(1, 0.1)


-- Inicializa un contador de preguntas correctas
correct_answers = 0
-- Inicializa un contador de respuestas incorrectas
incorrect_answers = 0
-- Inicializa una tabla para almacenar las preguntas presentadas
presented_questions = {}

-- Función para presentar una nueva pregunta
function present_question()
play_music(1, 0.1)
-- Verifica si el tiempo se ha acabado
if time_is_up() then
play_music(10, 0.3)
show_results()
return true
end

  -- Selecciona una pregunta aleatoria
  local current_question = questions[math.random(#questions)]

  -- Verifica si la pregunta seleccionada ya se ha presentado antes
  while presented_questions[current_question] do
    current_question = questions[math.random(#questions)]
  end

  -- Almacena la pregunta en la tabla de preguntas presentadas
  presented_questions[current_question] = true

  -- Crea una lista con las respuestas
  answers = {}
  for i, answer in ipairs(current_question.answers) do
    table.insert(answers, answer.text)
  end



  -- Crea la vista para la pregunta y las respuestas
  layout={
    GridView,
    id="grid",
    numColumns=1,
    items=answers,
    layout_width="fill",
    layout_height="fill"
  }
  -- Muestra la pregunta y las respuestas en un cuadro de diálogo
  dlg=LuaDialog(service)
  dlg.View=loadlayout(layout)
  dlg.setTitle(current_question.question)
  dlg.setButton("Cancel", nil)
  dlg.show()
  -- Handle click on answer
  grid.onItemClick = function(l, v)
    task(100, function()
      dlg.dismiss()
      -- Check if answer is correct
      for i, answer in ipairs(current_question.answers) do
        if answer.text == v.text and answer.correct then
          correct_answers = correct_answers + 1
if correct_answers == 5 then
play_music(7, 0.1)
present_question()
return true
else if correct_answers == 10 then
play_music(7, 0.1)
present_question()
return true
else if correct_answers == 15 then
play_music(7, 0.1)
play_music(12, 0.2)
present_question()
return true
else           if correct_answers == 20 then
            show_results()
play_music(11, 1.0)
            return true

          else
            present_question()
end
end
end
end
          return true
        elseif answer.text == v.text then
play_music(3, 0.2)
          incorrect_answers = incorrect_answers + 1
          present_question()
          if incorrect_answers == 5 then
show_results()
play_music(5, 0.3)
            correct_answers = 0
            incorrect_answers = 0
            dlg.dismiss()
          end
          return true
        end
      end
    end)
  end
end


function show_results()
  -- Crea la vista para el resultado
  local elapsed_time = os.time() - start_time
  result_layout = {
    LinearLayout,
    orientation = "vertical",
    layout_width = "fill",
    layout_height = "fill",
    {
      TextView,
      text = "Resultados",
      textSize = "24sp",
      layout_width = "fill",
      layout_height = "wrap_content",
      gravity = "center"
    },
    {
      TextView,
      text = "Preguntas Correctas: " .. correct_answers,
      textSize = "18sp",
      layout_width = "fill",
      layout_height = "wrap_content",
      gravity = "center"
    },
    {
      TextView,
      text = "Preguntas Incorrectas: " .. incorrect_answers,
      textSize = "18sp",
      layout_width = "fill",
      layout_height = "wrap_content",
      gravity = "center"
    },
    {
      TextView,
      text = "Tiempo Transcurrido: " .. elapsed_time .. " segundos",
      textSize = "18sp",
      layout_width = "fill",
      layout_height = "wrap_content",
      gravity = "center"








},
{
Button,
text = "Créditos",
textSize = "18sp",
layout_width = "wrap_content",
layout_height = "wrap_content",
onClick = function()
-- Acción al hacer clic en el botón de créditos
print("cómo cambiar el temporizador?")
print("puedes cambiar el límite de tiempo de este juego, en el editor de texto de lector jieshuo, simplemente haz una búsqueda con el término que te dejo debajo de esta línea, una vez que lo encuentres, cambia su número, recuerda que estos se expresan en segundos")
print("return os.time() - start_time >=")
print(" ")
print(" ")
print(" ")
print(" ")
print(" ")
print("juego creado por el usuario sergiopina")
print("parte del cuerpo administrativo, en el grupo de soporte en español, jieshuo latinoamérica por whatsapp")
print("recuerda que puedes acceder a este grupo de soporte mediante la aplicación, o por el enlace de aquí abajo, usa la función o r l para abrir los enlaces, no olvides presentarte con una nota de voz")
print("https://chat.whatsapp.com/IHcXLzpVo8n74HLAxb5rDz")
print("también te dejo el enlace al grupo, ayuda accesible, el mejor grupo y el más grande en latinoamérica, aquí podrás hablar libremente sobre cualquier tipo de aplicación y cualquier plataforma, también preséntate con una nota de voz")
print("https://chat.whatsapp.com/J7thEGVaI1tHw0r4jZbKlL")
print("link al canal de youtube,  ayuda accesible")
print("https://youtube.com/@ayudaaccesible2574")
print("canal jieshuo en español y más, aquí podrás aprender más con referente a sintaxis del lector jieshuo, y otras aplicaciones que interactúan con él")
print("https://youtube.com/@jieshuoenespanol")
print("link al canal, los audiolibros de sergio, audiolibros con voz neural por personaje")
print("https://youtube.com/@losaudiolibrosdesergio2")

play_music(4, 0.3)


end
},
{Button,
text = "guardar récord",
textSize = "18sp",
layout_width = "wrap_content",
layout_height = "wrap_content",
onClick = function()
play_music(9, 0.2)
-- Función para verificar si un archivo existe
function file_exists(path)
  local file = io.open(path, "r")
  if file then
    io.close(file)
    return true
  else
    return false
  end
end

-- Función para obtener la ruta completa del archivo resultados.txt
function get_results_file_path()
  local path1 = "/storage/emulated/0/解说/Plugins/el juego de preguntas/resultados.txt"
  local path2 = "/storage/emulated/0/解说/Complementos/el juego de preguntas/resultados.txt"
  if file_exists(path1) then
    return path1
  elseif file_exists(path2) then
    return path2
  else
    return nil
  end
end

-- Obtenemos la ruta completa del archivo resultados.txt
local results_file_path = get_results_file_path()

if results_file_path == nil then
  print("Archivo resultados.txt no encontrado")
else
  local file = io.open(results_file_path, "r")
  local contents = ""
  if file then
    contents = file:read("*all")
    file:close()
  end
  file = io.open(results_file_path, "w")
  if file then
    local date = os.date("%Y-%m-%d")
    local time = os.date("%X")
    file:write("Resultados (" .. date .. " " .. time .. ")\n")
    file:write("Preguntas Correctas: " .. correct_answers .. "\n")
    file:write("Preguntas Incorrectas: " .. incorrect_answers .. "\n")
    file:write("Tiempo Transcurrido: " .. elapsed_time .. " segundos\n")
    file:write(contents)
    file:close()
  else
    print("No se pudo abrir el archivo para escribir.")
  end
end
end


},
{Button,
text = "mostrar récords anteriores",
textSize = "18sp",
layout_width = "wrap_content",
layout_height = "wrap_content",
onClick = function()
play_music(8, 0.2)
function get_file_path(filename)
  local path1 = "/storage/emulated/0/解说/Plugins/" .. filename
  local path2 = "/storage/emulated/0/解说/Complementos/" .. filename
  if file_exists(path1) then
    return path1
  elseif file_exists(path2) then
    return path2
  else
    return nil
  end
end

function file_exists(path)
  local file = io.open(path, "r")
  if file then
    io.close(file)
    return true
  else
    return false
  end
end

local file_path = get_file_path("el juego de preguntas/resultados.txt")
if file_path then
  local file = io.open(file_path, "r")
  if file then
    for line in file:lines() do
      print(line)
    end
    file:close()
  else
    print("No se pudo abrir el archivo.")
  end
else
  print("No se encontró el archivo.")
end
end

},


{
Button,
text = "todas las preguntas con su respectiva respuesta correcta.",
textSize = "18sp",
layout_width = "wrap_content",
layout_height = "wrap_content",
onClick = function()
-- Acción al hacer clic en el botón de "Continuar Jugando"
play_music(11, 1.0)
show_incorrect_questions()
end
}
}
-- Muestra el resultado en un cuadro de diálogo
result_dlg = LuaDialog(service)
result_dlg.View = loadlayout(result_layout)
result_dlg.setTitle("aquí están tus Resultados, más opciones a la izquierda")
result_dlg.setButton("cerrar", nil)
result_dlg.show()
end
-- tabla para almacenar las preguntas incorrectas y sus respuestas correctas
incorrect_questions = {}
-- iteramos a través de todas las preguntas
for i, question in ipairs(questions) do
local found_correct_answer = false
for j, answer in ipairs(question.answers) do
-- verificamos si la respuesta es incorrecta
if not answer.correct then
-- buscamos la respuesta correcta
for k, a in ipairs(question.answers) do
if a.correct and not found_correct_answer then
found_correct_answer = true
-- agregamos la pregunta y la respuesta correcta a la tabla incorrect_questions
incorrect_questions[#incorrect_questions + 1] = {
question = question.question,
correct_answer = a.text
}
break
end
end
end
end
end
-- función para mostrar las preguntas incorrectas
function show_incorrect_questions()
if #incorrect_questions > 0 then
-- mostramos las preguntas incorrectas
for i, q in ipairs(incorrect_questions) do
print(q.question .. " - " .. q.correct_answer)
end
else
-- si no hay preguntas incorrectas, mostramos un mensaje
print("No hay preguntas incorrectas")
end
end




present_question()
play_music(7, 0.1)


  return true
end

    if v.text == "preguntas variadas de cultura general" then
--resuelto compatibilidad con ambas carpetas, 
--enseña todas las preguntas con todas sus respuestas correctas
--agregar botón cerrar, listo,
--música en toda la ronda listo,
--sonido en botones listo,
--juego de preguntas
require "import"
import "android.media.MediaPlayer"
import "android.widget.*"
import "com.androlua.*"
math.randomseed(os.time())
-- Inicializa un contador de tiempo inicial
start_time = os.time()
-- Función para verificar si el tiempo se ha acabado
function time_is_up()
return os.time() - start_time >= 90

end


-- Crea una lista de preguntas y respuestas
questions = {
{
question = "¿Quién es el creador de El Chavo del Ocho?",
answers = {
{ text = "Roberto Gómez Bolaños", correct = true },
{ text = "Carlos Villagrán", correct = false },
{ text = "María Antonieta de las Nieves", correct = false },
{ text = "Ramón Valdés", correct = false },
},
},
{
question = "¿Cuál es el nombre del personaje principal en El Chavo del Ocho?",
answers = {
{ text = "Ñoño", correct = false },
{ text = "El Chavo", correct = true },
{ text = "Doña Florinda", correct = false },
{ text = "Don Ramón", correct = false },
},
},
{
question = "¿En qué país se filmó El Chavo del Ocho?",
answers = {
{ text = "Argentina", correct = false },
{ text = "Brasil", correct = false },
{ text = "Chile", correct = false },
{ text = "México", correct = true },
},
},
{
question = "¿Cuándo se estrenó por primera vez El Chavo del Ocho en televisión?",
answers = {
{ text = "1981", correct = false },
{ text = "1991", correct = false },
{ text = "2001", correct = false },
{ text = "1971", correct = true },
},
},

{
question = "¿Cuál es uno de los programas de televisión más populares en América Latina?",
answers = {
{ text = "The Simpsons", correct = false },
{ text = "Friends", correct = false },
{ text = "Breaking Bad", correct = false },
{ text = "El Chavo del Ocho", correct = true },
},
},
{
question = "¿Quién es una de las estrellas de la televisión más reconocidas en América Latina?",
answers = {
{ text = "Chespirito", correct = true },
{ text = "Tom Cruise", correct = false },
{ text = "Brad Pitt", correct = false },
{ text = "Leonardo DiCaprio", correct = false },
},
},
{
question = "¿Qué tipo de programa de televisión es muy popular en América Latina?",
answers = {
{ text = "Programas de noticias", correct = false },
{ text = "Programas de cocina", correct = false },
{ text = "Novelas", correct = true },
{ text = "Programas de entretenimiento para niños", correct = false },
},
},
{
question = "¿Cuál es una de las estaciones de televisión más importantes en América Latina?",
answers = {
{ text = "Televisión Globo", correct = true },
{ text = "CNN", correct = false },
{ text = "BBC", correct = false },
{ text = "Al Jazeera", correct = false },
},
},

{
question = "¿Cuál es una de las principales causas de la discapacidad visual?",
answers = {
{ text = "Enfermedades degenerativas como la degeneración macular", correct = true },
{ text = "Lesiones en la cabeza", correct = false },
{ text = "Virus informáticos", correct = false },
{ text = "No hay ninguna causa específica", correct = false },
},
},
{
question = "¿Qué es un cane o bastón en el concepto de la accesibilidad?",
answers = {
{ text = "Un tipo de tecnología para hacer más difícil la vida de las personas con discapacidad", correct = false },
{ text = "Un tipo de arma", correct = false },
{ text = "Un dispositivo de apoyo utilizado por las personas con discapacidad visual para detectar obstáculos", correct = true },
{ text = "Un tipo de juguete", correct = false },
},
},
{
question = "¿Qué son los perros guía?",
answers = {
{ text = "Perros que no ayudan en absoluto a las personas con discapacidad", correct = false },
{ text = "Perros que hacen más difícil la vida de las personas con discapacidad", correct = false },
{ text = "Perros entrenados para ayudar a las personas con discapacidad visual a navegar por el mundo", correct = true },
{ text = "Perros que solamente se utilizan en el campo", correct = false },
},
},
{
question = "¿Qué es el braille?",
answers = {
{ text = "Un sistema de lectura que solamente se utiliza en el trabajo", correct = false },
{ text = "Un sistema de lectura táctil utilizado por las personas con discapacidad visual", correct = true },
{ text = "Un sistema de lectura que hace la vida más difícil para las personas con discapacidad visual", correct = false },
{ text = "Un sistema de lectura que no es útil para nadie", correct = false },
},
},

{
question = "¿Cuál es la capital de México?",
answers = {
{ text = "Guadalajara", correct = false },
{ text = "Monterrey", correct = false },
{ text = "Ciudad de México", correct = true },
{ text = "Puebla", correct = false },
},
},
{
question = "¿Quién es el fundador de la Teoría de la Relatividad?",
answers = {
{ text = "Isaac Newton", correct = false },
{ text = "Stephen Hawking", correct = false },
{ text = "Galileo Galilei", correct = false },
{ text = "Albert Einstein", correct = true },
},
},
{
question = "¿Qué es la tecnología de asistencia para personas con discapacidad?",
answers = {
{ text = "Un tipo de tecnología que no ayuda a nadie", correct = false },
{ text = "Una herramienta o dispositivo que ayuda a las personas con discapacidad a realizar tareas cotidianas", correct = true },
{ text = "Una tecnología que solamente se utiliza en el trabajo", correct = false },
{ text = "Una tecnología que es cara y no está disponible para todos", correct = false },
},
},
{
question = "¿Cuál es el objetivo principal de la accesibilidad web?",
answers = {
{ text = "Hacer que la web sea solamente para personas sin discapacidad", correct = false },
{ text = "No hacer nada para mejorar la accesibilidad en la web", correct = false },
{ text = "Aumentar los costos de la tecnología para las personas con discapacidad", correct = false },
{ text = "Permitir que las personas con discapacidad tengan acceso completo y sin obstáculos a los contenidos y funcionalidades en línea", correct = true },
},
},
{
question = "¿Qué es un teclado virtual en el contexto de la accesibilidad?",
answers = {
{ text = "Un teclado en pantalla que se utiliza para ingresar texto en un dispositivo", correct = true },
{ text = "Un teclado que solamente se utiliza para jugar videojuegos", correct = false },
{ text = "Un teclado que no ayuda a ninguna persona con discapacidad", correct = false },
{ text = "Un teclado que solamente se utiliza en dispositivos muy antiguos", correct = false },
},
},
{
question = "¿Qué es un lector de pantalla en el contexto de la accesibilidad?",
answers = {
{ text = "Un software que permite a las personas con discapacidad visual escuchar en voz alta el contenido en pantalla", correct = true },
{ text = "Un programa que hace que la información en pantalla sea más difícil de entender", correct = false },
{ text = "Un programa que solamente se utiliza en el trabajo", correct = false },
{ text = "Un programa que solamente se utiliza para personas sin discapacidad", correct = false },
},
},

{
question = "¿Quién pintó la Mona Lisa?",
answers = {
{ text = "Leonardo da Vinci", correct = true },
{ text = "Michelangelo", correct = false },
{ text = "Rafael", correct = false },
{ text = "Sandro Botticelli", correct = false },
},
},
{
question = "¿Cuál es el año de la independencia de Estados Unidos?",
answers = {
{ text = "1776", correct = true },
{ text = "1775", correct = false },
{ text = "1778", correct = false },
{ text = "1779", correct = false },
},
},
{
question = "¿Cuál es el mayor océano en el planeta?",
answers = {
{ text = "Océano Pacífico", correct = true },
{ text = "Océano Atlántico", correct = false },
{ text = "Océano Índico", correct = false },
{ text = "Océano Antártico", correct = false },
},
},
{
question = "¿Quién es el fundador de Amazon.com?",
answers = {
{ text = "Jeff Bezos", correct = true },
{ text = "Bill Gates", correct = false },
{ text = "Elon Musk", correct = false },
{ text = "Mark Zuckerberg", correct = false },
},
},
{
question = "¿Cuál es la obra más famosa de Shakespeare?",
answers = {
{ text = "Romeo y Julieta", correct = false },
{ text = "Hamlet", correct = true },
{ text = "Macbeth", correct = false },
{ text = "Othello", correct = false },
},
},
{
question = "¿Cuál es la moneda oficial de Japón?",
answers = {
{ text = "Dólar estadounidense", correct = false },
{ text = "Euro", correct = false },
{ text = "Yen japonés", correct = true },
{ text = "Libra esterlina", correct = false },
},
},
  {
question = "¿cuál es el mejor canal de youtube, para escuchar audiolibros?",
    answers = {
      { text = "los audiolibros de sergio", correct = true },
      { text = "hola soy germán", correct = false },
      { text = "auronplay", correct = false },
      { text = "el del innombrable", correct = false },
    },
  },

  {
question = "¿cuál es el mejor grupo de soporte, del lector jieshuo?",
    answers = {
      { text = "jieshuo latinoamérica", correct = true },
{ text = "jieshuo en español por telegram", correct = true },
      { text = "jieshuo en inglés por telegram", correct = true },
{ text = "jieshuo en español whatsapp", correct = true },
    },
  },

{
question = "Es grande y marrón, tiene un tronco grueso y ramas en lo alto. ¿Qué es?",
answers = {
{ text = "Un árbol", correct = true },
{ text = "Un coche", correct = false },
{ text = "Una casa", correct = false },
{ text = "Un barco", correct = false },
},
},
{
question = "Vuela en el aire, es delgado y tiene una cola larga. ¿Qué es?",
answers = {
{ text = "Un avión", correct = false },
{ text = "Un pájaro", correct = true },
{ text = "Un tren", correct = false },
{ text = "Un submarino", correct = false },
},
},
{
question = "Nace pequeño, crece grande y siempre tiene hambre. ¿Qué es?",
answers = {
{ text = "Un bebé", correct = false },
{ text = "Un perro", correct = false },
{ text = "Un elefante", correct = false },
{ text = "Un niño", correct = true },
},
},
{
question = "Tiene cuatro patas por la mañana, dos patas por la tarde y tres patas por la noche. ¿Qué es?",
answers = {
{ text = "Un hombre", correct = false },
{ text = "Un perro", correct = false },
{ text = "Un león", correct = false },
{ text = "Un hombre con un bastón", correct = true },
},
},
{
question = "Es redonda y hueca, tiene una cuerda para ser movida. ¿Qué es?",
answers = {
{ text = "Una pelota", correct = false },
{ text = "Una bolsa", correct = false },
{ text = "Un reloj", correct = false },
{ text = "Una campana", correct = true },
},
},


{
question = "¿En qué país se encuentra la Cordillera de los Andes?",
answers = {
{ text = "Chile", correct = false },
{ text = "Colombia", correct = false },
{ text = "Ecuador", correct = false },
{ text = "A lo largo de varios países, incluyendo Perú, Bolivia y Argentina", correct = true },
},
},
{
question = "¿Cuál es la capital de Uruguay?",
answers = {
{ text = "Montevideo", correct = true },
{ text = "Buenos Aires", correct = false },
{ text = "Lima", correct = false },
{ text = "Bogotá", correct = false },
},
},
{
question = "¿En qué país se encuentra la catarata del Iguazú?",
answers = {
{ text = "Brasil", correct = false },
{ text = "Argentina", correct = true },
{ text = "Colombia", correct = false },
{ text = "Perú", correct = false },
},
},
{
question = "¿Cuál es la moneda oficial de Venezuela?",
answers = {
{ text = "Peso Mexicano", correct = false },
{ text = "Peso Colombiano", correct = false },
{ text = "Peso Chileno", correct = false },
{ text = "Bolívar", correct = true },
},
},
{
question = "¿En qué país se encuentra la Isla de Pascua?",
answers = {
{ text = "Chile", correct = true },
{ text = "Perú", correct = false },
{ text = "Ecuador", correct = false },
{ text = "Argentina", correct = false },
},
},


{
question = "¿Cuál de estos países no pertenece a América Latina?",
answers = {
{ text = "Costa Rica", correct = false },
{ text = "Paraguay", correct = false },
{ text = "Venezuela", correct = false },
{ text = "Bahamas", correct = true },
},
},
{
question = "¿Qué país tiene la mayor superficie en América Latina?",
answers = {
{ text = "Argentina", correct = false },
{ text = "Brasil", correct = true },
{ text = "Colombia", correct = false },
{ text = "México", correct = false },
},
},
{
question = "¿Cuál es el país con la mayor cantidad de habitantes en América Latina?",
answers = {
{ text = "Argentina", correct = false },
{ text = "Colombia", correct = false },
{ text = "México", correct = false },
{ text = "Brasil", correct = true },
},
},
{
question = "¿En qué país se encuentra el río Amazonas?",
answers = {
{ text = "Colombia", correct = false },
{ text = "Perú", correct = false },
{ text = "Brasil", correct = true },
{ text = "Ecuador", correct = false },
},
},
{
question = "¿Cuál de estos países no limita con el Océano Pacífico?",
answers = {
{ text = "Chile", correct = false },
{ text = "Ecuador", correct = true },
{ text = "Perú", correct = false },
{ text = "Colombia", correct = false },
},
},


{
question = "¿Cuál es la ciudad más grande de México?",
answers = {
{ text = "Guadalajara", correct = false },
{ text = "Monterrey", correct = false },
{ text = "Ciudad de México", correct = true },
{ text = "Puebla", correct = false },
},
},
{
question = "¿Cuál es la moneda oficial de Colombia?",
answers = {
{ text = "Peso Mexicano", correct = false },
{ text = "Peso Chileno", correct = false },
{ text = "Peso Colombiano", correct = true },
{ text = "Quetzal Guatemalteco", correct = false },
},
},
{
question = "¿Cuál es el país con mayor cantidad de islas en América Latina?",
answers = {
{ text = "Brasil", correct = false },
{ text = "Argentina", correct = false },
{ text = "Chile", correct = false },
{ text = "Ecuador", correct = true },
},
},
{
question = "¿Cuál es la ciudad más antigua de América Latina?",
answers = {
{ text = "Lima", correct = false },
{ text = "Quito", correct = false },
{ text = "Ciudad de México", correct = false },
{ text = "Cusco", correct = true },
},
},


{
question = "¿Cuál es el país más grande de Latinoamérica en términos de superficie?",
answers = {
{ text = "Brasil", correct = true },
{ text = "Argentina", correct = false },
{ text = "México", correct = false },
{ text = "Colombia", correct = false },
},
},
{
question = "¿Cuál es la capital de Honduras?",
answers = {
{ text = "Managua", correct = false },
{ text = "San Salvador", correct = false },
{ text = "Tegucigalpa", correct = true },
{ text = "Panamá", correct = false },
},
},
{
question = "¿En qué país se encuentra la cueva de las manos?",
answers = {
{ text = "Argentina", correct = true },
{ text = "Brasil", correct = false },
{ text = "Uruguay", correct = false },
{ text = "Chile", correct = false },
},
},
{
question = "¿Cuál es el río más largo de América Latina?",
answers = {
{ text = "Río de la Plata", correct = false },
{ text = "Río Amazonas", correct = true },
{ text = "Río Paraná", correct = false },
{ text = "Río Magdalena", correct = false },
},
},


{
question = "¿Qué país es conocido por su Torre Eiffel?",
answers = {
{ text = "Italia", correct = false },
{ text = "España", correct = false },
{ text = "Francia", correct = true },
{ text = "Alemania", correct = false },
},
},
{
question = "¿Quién es el fundador de Facebook?",
answers = {
{ text = "Bill Gates", correct = false },
{ text = "Steve Jobs", correct = false },
{ text = "Mark Zuckerberg", correct = true },
{ text = "Elon Musk", correct = false },
},
},
{
question = "¿Cuál es la capital de Australia?",
answers = {
{ text = "Sydney", correct = false },
{ text = "Melbourne", correct = false },
{ text = "Adelaida", correct = false },
{ text = "Canberra", correct = true },
},
},
{
question = "¿Quién escribió la novela 'Drácula'?",
answers = {
{ text = "Mary Shelley", correct = false },
{ text = "Bram Stoker", correct = true },
{ text = "Edgar Allan Poe", correct = false },
{ text = "H.G. Wells", correct = false },
},
},

{
question = "¿Quién escribió la obra literaria 'Cien años de soledad'?",
answers = {
{ text = "Jorge Luis Borges", correct = false },
{ text = "Mario Vargas Llosa", correct = false },
{ text = "Octavio Paz", correct = false },
{ text = "Gabriel García Márquez", correct = true },
},
},
{
question = "¿Cuál es el monumento más famoso de París?",
answers = {
{ text = "Notre-Dame", correct = false },
{ text = "Torre Eiffel", correct = true },
{ text = "Arc de Triomphe", correct = false },
{ text = "Sainte-Chapelle", correct = false },
},
},
{
question = "¿Cuál es el país más pequeño del mundo en términos de superficie?",
answers = {
{ text = "Monaco", correct = false },
{ text = "Nauru", correct = false },
{ text = "El Vaticano", correct = true },
{ text = "Tuvalu", correct = false },
},
},
{
question = "¿Quién es el científico conocido como el padre de la teoría de la relatividad?",
answers = {
{ text = "Albert Einstein", correct = true },
{ text = "Isaac Newton", correct = false },
{ text = "Stephen Hawking", correct = false },
{ text = "Galileo Galilei", correct = false },
},
},
{
question = "¿Cuál es la catedral más grande de Inglaterra?",
answers = {
{ text = "Catedral de Canterbury", correct = false },
{ text = "Catedral de York", correct = false },
{ text = "Catedral de Westminster", correct = false },
{ text = "Catedral de San Pablo", correct = true },
},
},


{
question = "¿Cuál es la moneda oficial de España?",
answers = {
{ text = "Dólar estadounidense", correct = false },
{ text = "Euro", correct = true },
{ text = "Libra esterlina", correct = false },
{ text = "Yen japonés", correct = false },
},
},
{
question = "¿Quién fue el inventor del teléfono?",
answers = {
{ text = "Alexander Graham Bell", correct = true },
{ text = "Thomas Edison", correct = false },
{ text = "Nikola Tesla", correct = false },
{ text = "Eli Whitney", correct = false },
},
},
{
question = "¿Cuál es el país con la mayor población del mundo?",
answers = {
{ text = "China", correct = true },
{ text = "India", correct = false },
{ text = "Estados Unidos", correct = false },
{ text = "Indonesia", correct = false },
},
},
{
question = "¿Cuál es la ciudad más grande de Alemania?",
answers = {
{ text = "Berlín", correct = true },
{ text = "Múnich", correct = false },
{ text = "Fráncfort", correct = false },
{ text = "Hamburgo", correct = false },
},
},
{
question = "¿Cuál es el país más grande en términos de superficie?",
answers = {
{ text = "Estados Unidos", correct = false },
{ text = "Canadá", correct = false },
{ text = "China", correct = false },
{ text = "Rusia", correct = true },
},
},
{
question = "¿Quién fue el primer presidente de los Estados Unidos?",
answers = {
{ text = "Thomas Jefferson", correct = false },
{ text = "George Washington", correct = true },
{ text = "Abraham Lincoln", correct = false },
{ text = "Franklin D. Roosevelt", correct = false },
},
},
{
question = "¿Cuál es la capital de Francia?",
answers = {
{ text = "París", correct = true },
{ text = "Londres", correct = false },
{ text = "Madrid", correct = false },
{ text = "Berlín", correct = false },
},
},
{
question = "¿Quién es el autor de la novela 'Don Quijote de la Mancha'?",
answers = {
{ text = "Fyodor Dostoevsky", correct = false },
{ text = "William Shakespeare", correct = false },
{ text = "Miguel de Cervantes", correct = true },
{ text = "Mark Twain", correct = false },
},
},
  {
    question = "¿Cuál es el planeta más grande del sistema solar?",
    answers = {
      { text = "Júpiter", correct = true },
      { text = "Marte", correct = false },
      { text = "Saturno", correct = false },
      { text = "Venus", correct = false },
    },
  },
  {
    question = "¿Cuál es el animal más rápido del mundo?",
    answers = {
      { text = "Leopardo", correct = false },
      { text = "Jaguar", correct = false },
      { text = "Perezoso", correct = false },
      { text = "Guepardo", correct = true },
    },
  },
  {
    question = "¿Cuál es el río más largo del mundo?",
    answers = {
      { text = "Nilo", correct = true },
      { text = "Amazonas", correct = false },
      { text = "Yangtsé", correct = false },
      { text = "Mississippi", correct = false },
    },
  },
}
-- Función para obtener la ruta de los archivos de sonido
function get_file_path(filename)
  local path1 = "/storage/emulated/0/解说/Plugins/" .. filename
  local path2 = "/storage/emulated/0/解说/Complementos/" .. filename
  if file_exists(path1) then
    return path1
  elseif file_exists(path2) then
    return path2
  else
    return nil
  end
end

-- Función para verificar si un archivo existe
function file_exists(path)
  local file = io.open(path, "r")
  if file then
    io.close(file)
    return true
  else
    return false
  end
end

-- Lista de archivos de sonido


files = { 
"el juego de preguntas/healer_hit_02.ogg",
"el juego de preguntas/town_hall_upgrade_jingle_01.ogg",
"el juego de preguntas/wiz_death_vo_02.ogg",
"el juego de preguntas/sb_deploy_01.ogg",
"el juego de preguntas/clash_pet_horse_die_01.ogg",
"el juego de preguntas/leg_league_01.ogg",
"el juego de preguntas/candy_crush_soundtrack3.ogg",
"el juego de preguntas/supercell_jingle.ogg",
"el juego de preguntas/tutor_talk_aha_01.ogg",
"el juego de preguntas/clan_task_failed_01.ogg",
"el juego de preguntas/EFECTO DE SONIDO ¡WOW! (Chroma key).m4a",
"el juego de preguntas/últimas cinco preguntas.m4a"
}
function play_music(index, volume)
local file_path = get_file_path(files[index])
if file_path == nil then
print("Archivo no encontrado: " .. files[index])
return
end
local mp = MediaPlayer()
mp.setDataSource(file_path)

  mp.setVolume(volume, volume)
  mp.prepare()
  mp.start()
  mp.setOnCompletionListener(MediaPlayer.OnCompletionListener {
      onCompletion = function()
          mp.release()
      end
  })
end


play_music(1, 0.1)


-- Inicializa un contador de preguntas correctas
correct_answers = 0
-- Inicializa un contador de respuestas incorrectas
incorrect_answers = 0
-- Inicializa una tabla para almacenar las preguntas presentadas
presented_questions = {}

-- Función para presentar una nueva pregunta
function present_question()
play_music(1, 0.1)
-- Verifica si el tiempo se ha acabado
if time_is_up() then
play_music(10, 0.3)
show_results()
return true
end

  -- Selecciona una pregunta aleatoria
  local current_question = questions[math.random(#questions)]

  -- Verifica si la pregunta seleccionada ya se ha presentado antes
  while presented_questions[current_question] do
    current_question = questions[math.random(#questions)]
  end

  -- Almacena la pregunta en la tabla de preguntas presentadas
  presented_questions[current_question] = true

  -- Crea una lista con las respuestas
  answers = {}
  for i, answer in ipairs(current_question.answers) do
    table.insert(answers, answer.text)
  end



  -- Crea la vista para la pregunta y las respuestas
  layout={
    GridView,
    id="grid",
    numColumns=1,
    items=answers,
    layout_width="fill",
    layout_height="fill"
  }
  -- Muestra la pregunta y las respuestas en un cuadro de diálogo
  dlg=LuaDialog(service)
  dlg.View=loadlayout(layout)
  dlg.setTitle(current_question.question)
  dlg.setButton("Cancel", nil)
  dlg.show()
  -- Handle click on answer
  grid.onItemClick = function(l, v)
    task(100, function()
      dlg.dismiss()
      -- Check if answer is correct
      for i, answer in ipairs(current_question.answers) do
        if answer.text == v.text and answer.correct then
          correct_answers = correct_answers + 1
if correct_answers == 5 then
play_music(7, 0.1)
present_question()
return true
else if correct_answers == 10 then
play_music(7, 0.1)
present_question()
return true
else if correct_answers == 15 then
play_music(7, 0.1)
play_music(12, 0.2)
present_question()
return true
else           if correct_answers == 20 then
            show_results()
play_music(11, 1.0)
            return true

          else
            present_question()
end
end
end
end
          return true
        elseif answer.text == v.text then
play_music(3, 0.2)
          incorrect_answers = incorrect_answers + 1
          present_question()
          if incorrect_answers == 5 then
show_results()
play_music(5, 0.3)
            correct_answers = 0
            incorrect_answers = 0
            dlg.dismiss()
          end
          return true
        end
      end
    end)
  end
end


function show_results()
  -- Crea la vista para el resultado
  local elapsed_time = os.time() - start_time
  result_layout = {
    LinearLayout,
    orientation = "vertical",
    layout_width = "fill",
    layout_height = "fill",
    {
      TextView,
      text = "Resultados",
      textSize = "24sp",
      layout_width = "fill",
      layout_height = "wrap_content",
      gravity = "center"
    },
    {
      TextView,
      text = "Preguntas Correctas: " .. correct_answers,
      textSize = "18sp",
      layout_width = "fill",
      layout_height = "wrap_content",
      gravity = "center"
    },
    {
      TextView,
      text = "Preguntas Incorrectas: " .. incorrect_answers,
      textSize = "18sp",
      layout_width = "fill",
      layout_height = "wrap_content",
      gravity = "center"
    },
    {
      TextView,
      text = "Tiempo Transcurrido: " .. elapsed_time .. " segundos",
      textSize = "18sp",
      layout_width = "fill",
      layout_height = "wrap_content",
      gravity = "center"








},
{
Button,
text = "Créditos",
textSize = "18sp",
layout_width = "wrap_content",
layout_height = "wrap_content",
onClick = function()
-- Acción al hacer clic en el botón de créditos
print("cómo cambiar el temporizador?")
print("puedes cambiar el límite de tiempo de este juego, en el editor de texto de lector jieshuo, simplemente haz una búsqueda con el término que te dejo debajo de esta línea, una vez que lo encuentres, cambia su número, recuerda que estos se expresan en segundos")
print("return os.time() - start_time >=")
print(" ")
print(" ")
print(" ")
print(" ")
print(" ")
print("juego creado por el usuario sergiopina")
print("parte del cuerpo administrativo, en el grupo de soporte en español, jieshuo latinoamérica por whatsapp")
print("recuerda que puedes acceder a este grupo de soporte mediante la aplicación, o por el enlace de aquí abajo, usa la función o r l para abrir los enlaces, no olvides presentarte con una nota de voz")
print("https://chat.whatsapp.com/IHcXLzpVo8n74HLAxb5rDz")
print("también te dejo el enlace al grupo, ayuda accesible, el mejor grupo y el más grande en latinoamérica, aquí podrás hablar libremente sobre cualquier tipo de aplicación y cualquier plataforma, también preséntate con una nota de voz")
print("https://chat.whatsapp.com/J7thEGVaI1tHw0r4jZbKlL")
print("link al canal de youtube,  ayuda accesible")
print("https://youtube.com/@ayudaaccesible2574")
print("canal jieshuo en español y más, aquí podrás aprender más con referente a sintaxis del lector jieshuo, y otras aplicaciones que interactúan con él")
print("https://youtube.com/@jieshuoenespanol")
print("link al canal, los audiolibros de sergio, audiolibros con voz neural por personaje")
print("https://youtube.com/@losaudiolibrosdesergio2")

play_music(4, 0.3)


end
},
{Button,
text = "guardar récord",
textSize = "18sp",
layout_width = "wrap_content",
layout_height = "wrap_content",
onClick = function()
play_music(9, 0.2)
-- Función para verificar si un archivo existe
function file_exists(path)
  local file = io.open(path, "r")
  if file then
    io.close(file)
    return true
  else
    return false
  end
end

-- Función para obtener la ruta completa del archivo resultados.txt
function get_results_file_path()
  local path1 = "/storage/emulated/0/解说/Plugins/el juego de preguntas/resultados.txt"
  local path2 = "/storage/emulated/0/解说/Complementos/el juego de preguntas/resultados.txt"
  if file_exists(path1) then
    return path1
  elseif file_exists(path2) then
    return path2
  else
    return nil
  end
end

-- Obtenemos la ruta completa del archivo resultados.txt
local results_file_path = get_results_file_path()

if results_file_path == nil then
  print("Archivo resultados.txt no encontrado")
else
  local file = io.open(results_file_path, "r")
  local contents = ""
  if file then
    contents = file:read("*all")
    file:close()
  end
  file = io.open(results_file_path, "w")
  if file then
    local date = os.date("%Y-%m-%d")
    local time = os.date("%X")
    file:write("Resultados (" .. date .. " " .. time .. ")\n")
    file:write("Preguntas Correctas: " .. correct_answers .. "\n")
    file:write("Preguntas Incorrectas: " .. incorrect_answers .. "\n")
    file:write("Tiempo Transcurrido: " .. elapsed_time .. " segundos\n")
    file:write(contents)
    file:close()
  else
    print("No se pudo abrir el archivo para escribir.")
  end
end
end


},
{Button,
text = "mostrar récords anteriores",
textSize = "18sp",
layout_width = "wrap_content",
layout_height = "wrap_content",
onClick = function()
play_music(8, 0.2)
function get_file_path(filename)
  local path1 = "/storage/emulated/0/解说/Plugins/" .. filename
  local path2 = "/storage/emulated/0/解说/Complementos/" .. filename
  if file_exists(path1) then
    return path1
  elseif file_exists(path2) then
    return path2
  else
    return nil
  end
end

function file_exists(path)
  local file = io.open(path, "r")
  if file then
    io.close(file)
    return true
  else
    return false
  end
end

local file_path = get_file_path("el juego de preguntas/resultados.txt")
if file_path then
  local file = io.open(file_path, "r")
  if file then
    for line in file:lines() do
      print(line)
    end
    file:close()
  else
    print("No se pudo abrir el archivo.")
  end
else
  print("No se encontró el archivo.")
end
end

},


{
Button,
text = "todas las preguntas con su respectiva respuesta correcta.",
textSize = "18sp",
layout_width = "wrap_content",
layout_height = "wrap_content",
onClick = function()
-- Acción al hacer clic en el botón de "Continuar Jugando"
play_music(11, 1.0)
show_incorrect_questions()
end
}
}
-- Muestra el resultado en un cuadro de diálogo
result_dlg = LuaDialog(service)
result_dlg.View = loadlayout(result_layout)
result_dlg.setTitle("aquí están tus Resultados, más opciones a la izquierda")
result_dlg.show()
end
-- tabla para almacenar las preguntas incorrectas y sus respuestas correctas
incorrect_questions = {}
-- iteramos a través de todas las preguntas
for i, question in ipairs(questions) do
local found_correct_answer = false
for j, answer in ipairs(question.answers) do
-- verificamos si la respuesta es incorrecta
if not answer.correct then
-- buscamos la respuesta correcta
for k, a in ipairs(question.answers) do
if a.correct and not found_correct_answer then
found_correct_answer = true
-- agregamos la pregunta y la respuesta correcta a la tabla incorrect_questions
incorrect_questions[#incorrect_questions + 1] = {
question = question.question,
correct_answer = a.text
}
break
end
end
end
end
end
-- función para mostrar las preguntas incorrectas
function show_incorrect_questions()
if #incorrect_questions > 0 then
-- mostramos las preguntas incorrectas
for i, q in ipairs(incorrect_questions) do
print(q.question .. " - " .. q.correct_answer)
end
else
-- si no hay preguntas incorrectas, mostramos un mensaje
print("No hay preguntas incorrectas")
end
end




present_question()
play_music(7, 0.1)

      return true
    end

    if v.text == "espacio" then
      service.insert(node," ")
      return true
    end

    if v.text == "enter" then
      service.insert(node,"\n")
      return true
    else
      service.insert(node,v.text)
      return true
    end
  end)
end
return true